local function strash_log(p, q) -- debug
	strash_Log(p,q,"strashBot_msg_cmd")
end


local _msg_cmd= {}
rawset(_G,"strash_msg_cmd", {})


local function addMessageCommand(cmd_names, cmd_func)
    local name_table= (type(cmd_names)=="table") and cmd_names or { cmd_names }

    print("[strashbot] inserting cmd name - is table? "..((type(cmd_names)=="table") and "yes" or "no")..
                " that is "..((type(cmd_names)=="table") and (cmd_names[1]) or "whatever")
    )
    print("[strashbot] is final insert name in a table?"..((type(name_table)=="table") and "yes" or "no")..
                " that is "..((type(name_table)=="table") and (name_table[1]) or "whatever")
    )

    table.insert(_msg_cmd,
        {
            names= name_table,
            exec_func= cmd_func
        }
    )
end
strash_msg_cmd.addMessageCommand= addMessageCommand

local function extractArgsFromNamedCommandMsg(name, msg_str)
    if #name>=#msg_str then return {} end

    local args_table= {}
    local remaining_args= msg_str:sub(name:len()+2)
    while remaining_args~="" do
        strash_log(server, " - xtractArgs - - remainingArgs: '"..remaining_args.."'")
        local first_space_idx= remaining_args:find(" ")
        if first_space_idx==nil then
            table.insert(args_table, remaining_args)
            strash_log(server, " - xtractArgs - - args_table (1) + '"..remaining_args.."'")
            break
        else
            local arg= remaining_args:sub(1,first_space_idx-1)
            table.insert(args_table, arg)
            strash_log(server, " - xtractArgs - - args_table (2) + '"..arg.."'")
            remaining_args= remaining_args:sub(first_space_idx+1)
        end
    end

    return args_table
end

local function fetchRegisterMsgCommand(msg_str)
    local name_in_message= msg_str
    local first_space_idx= msg_str:find(" ")
    if first_space_idx~=nil then
        name_in_message= msg_str:sub(1, first_space_idx-1)
    end


    for i,cmd_obj in pairs(_msg_cmd) do
        strash_log(server,
            "found name in msg is '"..name_in_message.."'"..
            " - checking against "..i.." ; "..
            (   cmd_obj==nil and "nil" or (
                    (cmd_obj.names==nil and "no names" or (cmd_obj.names[1].." family"))
                )
            )
        )
        for j,name in pairs(cmd_obj.names) do
            strash_log(server, "-> '"..name.."' vs '"..name_in_message.."'")
            if name==name_in_message then
                return name, extractArgsFromNamedCommandMsg(name, msg_str), cmd_obj.exec_func
            end
        end
    end

    return nil
end

local function checkAndRunMsgCommand(msg_str, source, target)
    local cmd_given_name, cmd_args, cmd_func= fetchRegisterMsgCommand(msg_str)
    if(cmd_args) then
        strash_log(server, "- chechNRunMsgCmd - args is table? "..(type(cmd_args)=="table" and "y" or "n")..
                    " l? "..(#cmd_args)..
                    ((#cmd_args)>0 and (" first is "..cmd_args[1]) or "")
        )
    else
        strash_log(server, "- chechNRunMsgCmd - args is nil")
    end
	if cmd_given_name and cmd_func~=nil then
        return cmd_func(cmd_given_name, cmd_args, source, target)
	end

	return nil
end


addHook("PlayerMsg", function(source, msgtype, target, msg)
	if msgtype != 0 then return end
	
	local msg_lower= msg:lower()

    local prefix= msg_lower:sub(1,1)
    if prefix=="!" or prefix=="\\" then
        strash_log(server,"checking for existing cmd")
        local res= checkAndRunMsgCommand(msg_lower:sub(2), source, target)

        if res==nil then
            local str_end_idx= msg_lower:find(" ")
            str_end_idx= ($==nil) and (#msg_lower) or ($-1)
            CONS_Printf(source, "'\129"..msg_lower:sub(1, str_end_idx).."\128' unrecognized command...")
        end

        return res
    else
        return false
    end
end)
