--- TODO ---
-- - * Play sound when displaying message about SPB
-- - -- - (Was thinking about navy's 'look' and 'watchout'
-- - -- -  respectively when being toggle off and on )
--- ---


local strash_log= strash_Log -- debug

local _init= nil
local function try_initVar()
	if _init then return end
	
	strash_log(server, "_initializing")
	_init= {
		spbatk= CV_FindVar("spbatk"),
		trick_reminder= CV_FindVar("ac_trickreminder"),
		driftg= CV_FindVar("driftgauge"),
		funnydeath= CV_FindVar("fd_enable"),
		tags= nametagactive
	}
	
	if consoleplayer then
		if _init.tags and _init.tags.value then
			COM_BufInsertText(consoleplayer, "nametag off")
		end
		if _init.driftg and _init.driftg.value then
			COM_BufInsertText(consoleplayer, "driftgauge off")
		end
	end
	strash_ConfigLoad()
end

local function cons_cross_msg(msg)
	if server~=nil and msg and (#msg>0) then
		CONS_Printf(server,"<<<strash<<< "..msg.." >>>>>>>>>>>>")
	end
end


local function countplayers(includespec)
	includespec= (includespec ~=nil and includespec or false)
    local n = 0
    for p in players.iterate do
		if (includespec or (not p.spectator)) and p.mo then n = $+1 end
    end
    return n
end





local function getmapid(n)
    if n<100 then
        return (n<10) and ("0"..n) or tostring(n)
    end

    local x= n-100
    local p= x/36
    local q= x-(36*p)
    local a= string.char(string.byte('A')+p)
    local b= (q<10) and tostring(q) or string.char(string.byte('A')+q-10)

    return a..b
end

local function  strashMapList()
	if (not server) or server.strash_mapListed then return end
    local max= (36*26+26)+100
	local sep= "::::"

    for i=0,max do
        local map= mapheaderinfo[i]
        if map and map.lvlttl then

			cons_cross_msg("MAP"..getmapid(i)..sep..map.lvlttl..sep..
				((map.zonttl and #map.zonttl>0) and map.zonttl or "Zone")..sep..
				(map.subttl and map.subttl or "")..sep..
				map.typeoflevel..sep..map.levelflags..sep..map.menuflags
			)
        end
    end
	cons_cross_msg("MAP_LIST_DONE")
	
	server.strash_mapListed= true
end

local function  strashSkinList()
	if (not server) or server.strash_skinListed then return end
	local sep= "::::"
	
	local num= (#skins<127) and num or 127
	for i=0,num do
		local skin= skins[i]
		if skin and skin.name then
			cons_cross_msg("SKIN"..sep..skin.realname..sep..skin.name..sep..
				skin.kartspeed..sep..skin.kartweight
			)
		end
	end
	if #skins>127 then
		cons_cross_msg("SKIN_ALERT_EXCESS"..sep..#skins)
	end
	
	cons_cross_msg("SKIN_LIST_DONE")
	server.strash_skinListed= true
end



local DEFAULT_COOL_DOWN= 3

local function _findWhitelistedCmd(cmdName)
		local idx= 0
		if not server.HMvotable then server.HMvotable = {} end
		for i,v in pairs(server.HMvotable)
			if v == cmdName then
				idx= i
			end
		end
		return idx
end

local function _cmdVoteCheck(cmdname, fn, p)
	strash_log(p,"cmdVoteCheck on "..cmdname)
	local wl= _findWhitelistedCmd(cmdname)
	if wl or (p==server) or (IsPlayerAdmin(p)) then
		if wl then table.remove(server.HMvotable, wl) end
		strash_log(p,"+ ---> calling on_func")
		fn(p)
	end
end

local b_reactivate_spba= false
strash_mods.add_mod("Elim",
	function(p)
		strash_log(p, "executing elim on_func...")
		-- this little shit was breaking elimination, lol
		if (_init and _init.spbatk and _init.spbatk.value) then
			COM_BufInsertText(p, "spbatk off")
			b_reactivate_spba= true
		end
		COM_BufInsertText(p, "elimination on" )
	end,
	function(p)
		strash_log(p, "executing elim off_func...")
		COM_BufInsertText(p, "elimination off" )
		COM_BufInsertText(p, "basenumlaps \"Map Default\"" )
		if (b_reactivate_spba) then
			COM_BufInsertText(p, "spbatk on")
			b_reactivate_spba= false
		end
	end,
	nil,
	function(p, manual)
		strash_log(p, "executing elim activationCondition_func "..(manual and "(manual)" or "(auto)"))
		local c_p= countplayers()
		if ((not manual) and c_p<3) then
			strash_log(p, "\"EliminationMod\" won't be auto launched under 3 players")
			return false
		elseif manual and c_p<2 then
			strash_log(p, "\"EliminationMod\" can't be manually launched under 2 players")
			return false
		end
		return true
	end,
	3 -- minAutoRoundCoolDown
	--{"Friend", "Cruel"}
)


local jb_wait= nil
strash_mods.add_mod("JuiceBox",
	function(p)
		strash_log(p, "executing juicebox on_func...")
		-- COM_BufInsertText(p, "juicebox on" )
		jb_wait= true
		-- print("juicebox mode will be turned on next round")
	end,
	function(p)
		-- COM_BufInsertText(p, "juicebox off" )
		strash_log(p, "executing juicebox off_func...")
		jb_wait= false
		-- print("juicebox mode will be turned off next round")
	end,
	function(p)
		strash_log(p, "executing juicebox changeLevel_func...")
		if jb_wait~=nil then
			COM_BufInsertText(p, "juicebox "..(jb_wait and "on" or "off") )
			if jb_wait and not (_init.funnydeath and _init.funnydeath.value) then
				COM_BufInsertText(p,
					"respawndelay "..((not (_init.funnydeath and _init.funnydeath.value)) and
											"0" or "1"
					)
				)
			elseif (not jb_wait) then
				COM_BufInsertText(p, "respawndelay 1")
			end
			jb_wait= nil
		end
	end,
	function(p,manual)
		strash_log(p, "executing juicebox activationCondition_func "..(manual and "(manual)" or "(auto)"))
		if ((not manual) and countplayers()<2) then
			strash_log(p, "\"JuiceBox\" won't be auto launched under 2 players")
			return false
		end
		return true
	end,
	3, --minAutoRoundCoolDown
	strash_mods.ANNOUNCEMENT_FLAG.allExcept( strash_mods.ANNOUNCEMENT_FLAG.BATTLE )
)

strash_mods.add_mod("Friend",
	function(p)
		strash_log(p, "executing friend on_func...")
		COM_BufInsertText(p, "fr_enabled on" )
	end,
	function(p)
		strash_log(p, "executing friend off_func...")
		COM_BufInsertText(p, "fr_enabled off" )
	end,
	nil,
	function(p,manual)
		strash_log(p, "executing friend activationCondition_func "..(manual and "(manual)" or "(auto)"))
		if(manual and countplayers()<3) then
			chatprint("\"\131FriendMod\128\" can't be played under\133 3 \128players!")
			return false
		elseif ((not manual) and countplayers()<4) then
			strash_log(p, "\"FriendMod\" won't be auto launched under 4 players")
			return false
		end
		return true
	end,
	3, --minAutoRoundCoolDown
	strash_mods.ANNOUNCEMENT_FLAG.allExcept( strash_mods.ANNOUNCEMENT_FLAG.BATTLE )
	--{"Elim"}
)

local acro_wait=nil
strash_mods.add_mod("Acro",
	function(p)
		strash_log(p, "executing acrobatics on_func...")
		-- COM_BufInsertText(p, "ac_active on" )
		acro_wait= true
		-- print("acrobatics mode will be turned on next round")
	end,
	function(p)
		strash_log(p, "executing acrobatics off_func...")
		-- COM_BufInsertText(p, "ac_active off" )
		acro_wait= false
		-- print("acrobatics mode will be turned off next round")
	end,
	function(p)
		strash_log(p, "executing acrobatics changeLevel_func...")
		if acro_wait~=nil then
			COM_BufInsertText(p, "ac_active "..(acro_wait and "on" or "off") )
			acro_wait= nil
		end
	end,
	nil,
	0, --minAutoRoundCoolDown
	strash_mods.ANNOUNCEMENT_FLAG.ALWAYS,
	nil,
	true
)

local cruel_wait= nil
strash_mods.add_mod("Cruel",
	function(p)
		strash_log(p, "executing cruel on_func...")
		-- COM_BufInsertText(p, "ac_active on" )
		cruel_wait= true
		-- print("acrobatics mode will be turned on next round")
	end,
	function(p)
		strash_log(p, "executing cruel off_func...")
		-- COM_BufInsertText(p, "ac_active off" )
		cruel_wait= false
		-- print("acrobatics mode will be turned off next round")
	end,
	function(p)
		strash_log(p, "executing cruel changeLevel_func...")
		if cruel_wait~=nil then
			local command= (cruel_wait
				and "fd_enable On; fd_hitkill On; fd_finishkill Off; hpmod_enabled On; hpmod_wallbonkdamage On; hpmod_honorablementions Off; hpmod_bonuspoints On; hpmod_hurryup Off; hq_huge On; hq_orbigift On; hq_yeet On; hq_offroad On; hq_eggkarma On; eggpanic On; eggbump On; eggbox_extend On"
				or "fd_enable Off; fd_hitkill Off; hpmod_enabled Off; hq_huge Off; hq_orbigift Off; hq_yeet Off; hq_offroad Off; hq_mtstore Off; hq_sparkle Off; hq_skittles Off; hq_eggkarma Off; eggpanic Off; eggbump Off; eggbox_extend Off"
			)
			
			COM_BufInsertText(p, command)
			cruel_wait= nil
		end
	end,
	function(p,manual)
		strash_log(p, "executing cruel activationCondition_func "..(manual and "(manual)" or "(auto)"))
		if ((not manual) and countplayers()<2) then
			strash_log(p, "\"Cruel\" won't be auto launched under 2 players")
			return false
		end
		return true
	end,
	3, --minAutoRoundCoolDown
	strash_mods.ANNOUNCEMENT_FLAG.ALWAYS,
	nil,--{"Elim"},
	true
)

-- -- Settings mod sounds when race starts -- --
if FRIENDMOD_CheckTeams then
	strash_mods.setModSound("Friend",sfx_fmteam, function()
		if not FRIENDMOD_CheckTeams() then return false end
		if not FRIENDMOD_GetScores return true end
		
		local finalrecalc, bluescore, orangescore, bossplayer= FRIENDMOD_GetScores()
		return not(bossplayer)
	end)
	
	strash_mods.setModSound("DEFAULT_SOUND",sfx_fmffa)
end

freeslot("sfx_stcrul")
if hpmod and fd_loaded~=nil then
	strash_mods.setModSound("Cruel",sfx_stcrul)
end

freeslot("sfx_stelim")
if Elimination then
	strash_mods.setModSound("Elim",sfx_stelim)
end

freeslot("sfx_stjuib")
if JUICEBOX then
	strash_mods.setModSound("JuiceBox",sfx_stjuib)
end

-- -- -- --

for modName,t in pairs(strash_mods.mods) do
	t.cool_down= 0
	strash_log(server, "yeah adding setting "..modName.."'s cool_down to "..t.cool_down)
	t.base_cool_down= DEFAULT_COOL_DOWN
	strash_log(server, "... and "..modName.."'s base_cool_down to "..t.base_cool_down)

    local cmd_on= modName:lower().."_on"
    COM_AddCommand(cmd_on,
            function(p) _cmdVoteCheck(cmd_on,
                function (p)
					strash_mods.manuallyToggleMod(p, modName, true)
                end,
                p
            ) end,
            1
    )
    local cmd_off= modName:lower().."_off"
    COM_AddCommand(cmd_off,
        function (p)
			strash_mods.manuallyToggleMod(p, modName, false)
        end,
        1
    )
end

COM_AddCommand("every_mod_on",
	function(p)
		for modName,t in pairs(strash_mods.mods) do
			strash_mods.manuallyToggleMod(p, modName, true)
		end
	end,
	1
)
COM_AddCommand("every_mod_off",
	function(p)
		for modName,t in pairs(strash_mods.mods) do
			strash_mods.manuallyToggleMod(p, modName, false)
		end
	end,
	1
)

COM_AddCommand("issou_nightclub", function(p) COM_BufInsertText(p, "kartencore on; wait 35; map map40") end, 1)



local function voteCtrl(p, modName, toggleType)
	toggleType= toggleType~=nil and toggleType or true


	strash_log(server, "voteCtrl '"..
		(p==nil and 'nil player' or p.name).."' '"..
		modName.."' "..(toggleType and 'true' or 'false')
	)

	local cmdname= modName:lower()..(toggleType and "_on" or "_off")
	local wl= _findWhitelistedCmd(cmdname)
	if not wl then
		if strash_mods.mods[modName] then
			if strash_mods.mods[modName].cool_down>0 then
				chatprint("\133You have to wait "..strash_mods.mods[modName].cool_down.." rounds before casting another vote for '"..cmdname.."'.\128")
			else
				table.insert(server.HMvotable, cmdname)
				strash_log(server, "inserting '"..cmdname.."' into HMVotable...")
				
				COM_BufInsertText(p, "vote "..cmdname )
				strash_mods.mods[modName].cool_down=  strash_mods.mods[modName].base_cool_down
			end
		end
	else
		COM_BufInsertText(p, "vote "..cmdname )
		strash_mods.mods[modName].cool_down=  strash_mods.mods[modName].base_cool_down
	end
end



local function _l_restartLevel(p)
	strash_log(p,"calling '_l_restart_level()'")
	strash_mods.change_level_call(p)
	COM_BufInsertText(p, "restartlevel")
end
COM_AddCommand("restart_level", _l_restartLevel, 1)



local function resetScores(player)
	for p in players.iterate do
		p.score= 0
	end
	chatprint("\135|!| \135Players score reset.\128")
end
COM_AddCommand("reset_scores", resetScores, 1)


strash_info_msg_add('EASSPEED',
	"\133<\130STRASHBOT\133>\128 Hum... Wow... Server is actually in \133easy speed\128... Grow up, NOW, and use '\131!speed hard\128' in \129chat\128!",
	12, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (gamespeed==0 and gametype==0)
		strash_log(p,'SPBATKON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('NORSPEED',
	"\133<\130STRASHBOT\133>\128 Come on! Server is currently in \133normal speed\128... Step up and use '\131!speed hard\128' in \129chat\128!",
	12, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (gamespeed==1)
		strash_log(p,'SPBATKON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('SPBATKON',
	"\133<\130STRASHBOT\133>\128 Mean \133SPB\128 keeps wrecking you in soloplay? Call it off by using '\131!spb\128' in \129chat\128!",
	4, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (_init and _init.spbatk and _init.spbatk.value and countplayers()<=1)
		strash_log(p,'SPBATKON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('SPBATKOFF',
	"\133<\130STRASHBOT\133>\128 Want a solo challenge? Use '\131!spb\128' in \129chat\128 to toggle '\129SPBAttack\128'!",
	4, 0,
	function(p)
		if not p or p.spectator then return false end
		local b= (_init and _init.spbatk and (not _init.spbatk.value) and countplayers()<=1)
		strash_log(p,'SPBATKOFF cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('SPBATKNOACRO',
	"\133<\130STRASHBOT\133>\128 BTW, '\129Acrobatics\128' won't work while playing '\129SPBAttack\128'...",
	0, 0,
	function(p)
		if not p or p.spectator then return false end
		local t= strash_mods.mods['Acro']
		local b= (_init and _init.spbatk and _init.spbatk.value and t and t.activated and countplayers()<=1)
		strash_log(p,'SPBATKNOACRO cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('DRIFTGON',
	"\133<\130STRASHBOT\133>\128 Enough with the '\129Drift Gauge\128'? Use '\131!drift\128' in \129chat\128 to toggle if off!",
	0, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (_init and _init.driftg and _init.driftg.value)
		strash_log(p,'DRIFTGON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('DRIFTGOFF',
	"\133<\130STRASHBOT\133>\128 Not an expert at drifting yet? Use '\131!drift\128' in \129chat\128 to toggle the '\129Drift Gauge\128'!",
	0, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (_init and _init.driftg and (not _init.driftg.value))
		strash_log(p,'DRIFTGOFF cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('TAGSON',
	"\133<\130STRASHBOT\133>\128 Enough with all the '\129Name Tags\128' in race? Use '\131!tags\128' in \129chat\128 to hide them!",
	0, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (_init and _init.tags and _init.tags.value and countplayers()>2)
		strash_log(p,'TAGSON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('TAGSOFF',
	"\133<\130STRASHBOT\133>\128 Not sure who that <#$!@&> is? Use '\131!tags\128' in \129chat\128 to display the '\129Name Tags\128' in race!",
	0, 1,
	function(p)
		if not p or p.spectator then return false end
		local b= (_init and _init.tags and (not _init.tags.value) and countplayers()>2)
		strash_log(p,'TAGSOFF cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('ACROON',
	"\133<\130STRASHBOT\133>\128 Want more dynamic races? Use '\131!acro on\128' in \129chat\128 to ask for '\129Acrobatics\128'!",
	0, 2,
	function(p)
		if not p or p.spectator then return false end
		local t= strash_mods.mods['Acro']
		local b= (t and (not t.activated) and (not t.manually_activated) and
			(countplayers()>1 or (not _init) or (not _init.spbatk) or not _init.spbatk.value)
		)
		strash_log(p,'ACROON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('ACROOFF',
	"\133<\130STRASHBOT\133>\128 Don't like air tricks? Use'\131!acro off\128' in \129chat\128 to ask to remove '\129Acrobatics\128'!",
	0, 2,
	function(p)
		if not p or p.spectator then return false end
		local t= strash_mods.mods['Acro']
		local b= (t and t.activated and t.manually_activated and
			(countplayers()>1 or (not _init) or (not _init.spbatk) or not _init.spbatk.value)
		)
		strash_log(p,'ACROOFF cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('CMDREMIND',
	"\133<\130STRASHBOT\133>\128 Show rankings/scoreboard to display a reminder of \129chat commands\128.",
	0, 3,
	function(p)
		if not p then return false end
		local b= (HM_Scoreboard_AddTip ~= nil)
		strash_log(p,'CMDREMIND cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('CRUELON',
	"\133<\130STRASHBOT\133>\128 We don't talk about '\133cruel mode\128' (we don't use '\131!cruel on\128' in \129chat\128!)",
	0, 6,
	function(p)
		if not p then return false end
		local t= strash_mods.mods['Cruel']
		local b= (t and (not t.activated) and (not t.manually_activated) and countplayers()>1)
		strash_log(p,'CRUELON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('CRUELOFF',
	"\133<\130STRASHBOT\133>\128 Huh? You okay? You can stop this awfull '\133cruel mode\128' by using '\131!cruel off\128' in \129chat\128, y'know...",
	5, 3,
	function(p)
		if not p then return false end
		local t= strash_mods.mods['Cruel']
		local b= (t and t.activated and t.manually_activated)
		strash_log(p,'CRUELON cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('BATLONLY',
	"\133<\130STRASHBOT\133>\128 WTF?! Server is in '\133BATTLE ONLY\128'?! Use '\131!race\128' in \129chat\128 right now, to alternate gametypes! Now!!!",
	3, 1,
	function(p)
		if not p then return false end
		local gts= strash_gametype.evaluateCurrentGameTypeSetting()
		local b= (gts==strash_gametype.GAMETYPE_SETTINGS.BATTLE_ONLY)
		strash_log(p,'BATLONLY cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('RACLONLY',
	"\133<\130STRASHBOT\133>\128 FYI, server is in '\133race only\128' mode. Can use '\131!battle\128' in chat to rotate gametypes sometimes...",
	5, 3,
	function(p)
		if not p then return false end
		local gts= strash_gametype.evaluateCurrentGameTypeSetting()
		local b= (gts==strash_gametype.GAMETYPE_SETTINGS.RACE_ONLY)
		strash_log(p,'BATLONLY cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('SWCHGTYP',
	"\133<\130STRASHBOT\133> Server is currently \133rotating\128 between \133battle and race\128. Use '\131!race!\128' in \129chat\128 to switch to race only!\128",
	4, 3,
	function(p)
		if not p then return false end
		local gts= strash_gametype.evaluateCurrentGameTypeSetting()
		local b= (gts==strash_gametype.GAMETYPE_SETTINGS.SWITCHING)
		strash_log(p,'BATLONLY cond_func returns '..(b and 'true' or 'false'))
		return b
	end
)
strash_info_msg_add('DYKEMOTE',
	"\133<\130STRASHBOT\133>\128 DYK? You can use sh*tty \129emotes\128 in races by binding the \133custom actions\128 to buttons in player's \131controll setup\128!",
	0, 3,
	function(p)
		if (not p) or (p.spectator) then return false end
		return true
	end
)



addHook("PlayerQuit", function(player, reason)
	strash_log(server,"'"..(player and player.name or "unknown player").."' quit")
	local c=0
	for p in players.iterate do
		if p.valid then
			c = $+1
		end
    end
	strash_log(server,""..c.." players remaining")
	if(c<=2) then
		if _init and _init.spbatk then
			COM_BufInsertText(server, "spbatk off")
		end
	end
	if(c<=1) then
		COM_BufInsertText(server, "kartspeed hard")

		strash_mods.onServerEmpty_prepareReset()
		strash_gametype.onServerEmpty_prepareReset()

		COM_BufAddText(server, "map "..G_BuildMapName(0).." -gametype 0 -force")
	end
end)

addHook("ThinkFrame", function()
	try_initVar()
	
	if leveltime==0 then
		if not server.strash_mapListed then
			strashMapList()
		end
		
		if not server.strash_skinListed then
			strashSkinList()
		end
	end
	
	if not server.strash_modChange then
		server.strash_modChange = true
	end
	
	local c_p= countplayers()
	if (leveltime>1) then
		if (server.lastcountactive==0 and c_p==1) then
			if (not _init) or (not _init.spbatk) or (not _init.spbatk.value) then
				G_ExitLevel(gamemap, true)
			end
		end
	end
	server.lastcountactive= c_p
	
	-- yeah, I would like very much for JuiceBox to not interfere with respawn when funnyDeath is on
	-- but this is the only hacky way I could come up with
	if ( ((JUICEBOX and JUICEBOX.value) or (JUICEBOX_forcefastrespawn and JUICEBOX_forcefastrespawn.value))
		and _init.funnydeath and _init.funnydeath.value)
	then
		for p in players.iterate do
			p.respawnflash= 0
			if S_IdPlaying(sfx_s3kaf) and p.mo then
				--S_StopSoundByID(p.mo,sfx_s3kaf)
				sfxinfo[sfx_s3kaf].singular= true
				S_StartSoundAtVolume(nil,sfx_s3kaf,0)
			end
		end
	end
end)


local function _onGametypeStrChange(gt_str, msg, source)
	if (msg:sub(1,#gt_str)==gt_str) then
		if(msg:sub(-1,-1)=="!" or msg:sub(-5,-1)==" only") then
			local ctrl_gs= (gt_str=="battle")
							and strash_gametype.GAMETYPE_SETTINGS.BATTLE_ONLY
							or strash_gametype.GAMETYPE_SETTINGS.RACE_ONLY
			if strash_gametype.evaluateCurrentGameTypeSetting()~=ctrl_gs then
				COM_BufInsertText(source, "vote "..gt_str.."_only")
			else
				chatprintf(source, "\133<\130STRASHBOT\133>\128 '\129"..gt_str.."\128' is already the only gametype...")
			end

			return true
		elseif ((#msg)==(#gt_str)) or (msg:sub(-1,-1)=="?")
			local ctrl_gs= (gt_str~="battle")
							and strash_gametype.GAMETYPE_SETTINGS.BATTLE_ONLY
							or strash_gametype.GAMETYPE_SETTINGS.RACE_ONLY
			if strash_gametype.evaluateCurrentGameTypeSetting()==ctrl_gs then
				COM_BufInsertText(source, "vote race_n_battle")
			else
				chatprintf(source, "\133<\130STRASHBOT\133>\128 '\129"..gt_str.."\128' is already in the rotation...")
			end

			return true
		end

		return false
	end

	return false;
end





strash_msg_cmd.addMessageCommand(
	"kick",
	function(name, args, source, target)
		COM_BufInsertText(source, "vote kick \""..args[1].."\"")

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"restartlevel","restart","restart_level"},
	function(name, args, source, target)
		if name=="restart" and args[1]~="level" then
			return false
		end

		COM_BufInsertText(source, "vote restart_level")

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"issou", "issou_nightclub", "issounightclub"},
	function(name, args, source, target)
		if name=="issou" and
			#args>0 and args[1]~="nightclub"
		
		then
			return false
		end

		COM_BufInsertText(source, "vote issou_nightclub")

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"reset_scores", "reset", "reset_score"},
	function(name, args, source, target)
		if name=="reset" and #args>0
			and args[1]~="score" and args[1]~="score"
		then
			return false
		end

		COM_BufInsertText(source, "vote reset_scores")

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"tag","tags","name","names","plate","plates","nameplates","nameplate"},
	function(name, args, source, target)
		if _init and _init.tags then
			COM_BufInsertText(source, "nametag "..(_init.tags.value and "off" or "on"))
			chatprintf(source, "\133<\130STRASHBOT\133>\128 In race '\129Tags\128' are now "..
				(_init.tags.value and "\131Shown" or "\133Hidden").."\128!"
			)
			
			strash_SaveVariable(source,"nametag")
		end
		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"speed","kartspeed","kart"},
	function(name, args, source, target)
		local speed_arg= args[1]
		if name=="kart" and
			~args>0 and args[1]~="speed"
		then
			return false
		elseif #args>1
			speed_arg= args[2]
		end

		if(speed_arg=="normal" and gamespeed~=1) then
			COM_BufInsertText(source, "vote kartspeed Normal")
		elseif(speed_arg=="hard" and gamespeed~=2) then
			COM_BufInsertText(source, "vote kartspeed Hard")
		elseif(speed_arg=="easy" and gamespeed~=0) then
			COM_BufInsertText(source, "vote kartspeed Easy")
		end

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"normal","easy","hard","normalspeed","easyspeed","hardspeed"},
	function(name, args, source, target)
		local speed_arg=""
		if #args>0 and args[1]=="speed" then
			speed_arg= name
		elseif name:sub(-5)=="speed" then
			speed_arg= name:sub(-6)
		else
			return false
		end

		if speed_arg=="normal" and gamespeed~=1 then
			COM_BufInsertText(source, "vote kartspeed Normal")
		elseif speed_arg=="hard" and gamespeed~=2 then
			COM_BufInsertText(source, "vote kartspeed Hard")
		elseif speed_arg=="easy" and gamespeed~=0 then
			COM_BufInsertText(source, "vote kartspeed Easy")
		end

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"drift","gauge","driftgauge"},
	function(name, args, source, target)
		if not source.spectator and _init and _init.driftg then
			COM_BufInsertText(source, "driftgauge "..(_init.driftg.value and "off" or "on"))
			chatprintf(source, "\133<\130STRASHBOT\133>\128 Your '\129Drift Gauge\128' is "..
				(_init.driftg.value and "\131On" or "\133Off").."\128!"
			)
			
			strash_SaveVariable(source,"driftgauge")
		end
		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"every","everymod"},
	function(name, args, source, target)
		local toggle= "on"
		if name=="every" and
			#args>0 and args[1]=="mod"
		then
			toggle= (#args>1 and args[2]=="off") and "off" or "on"
		else
			toggle= ((#args>0) and args[1]=="off") and "off" or "on"
		end

		COM_BufInsertText(source, "vote every_mod_"..toggle)

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	"spb",
	function(name, args, source, target)
		if not source.spectator then
			local elimMod= strash_mods.mods["Elim"]
			-- want to make sure, spb chat command can't be used in elim mode,
			-- when there's the last man stranding
			-- so I check mod is active, and if it is,
			-- the only moment where the spb chat command can called
			-- is when the only player is not exiting
			local test= not(elimMod and elimMod.activated)
			if(countplayers()<=1) then
				if not test then
					for p in players.iterate do
						if (not p.spectator) and (not p.exiting) then
							strash_log("TEST: p.spectator? "..(p.spectator and "yes" or "no").."; "..
										"p.exiting? "..(p.exiting or "no")
							)
							test= true
						end
					end
				end
				if test then
					if _init and _init.spbatk then
						COM_BufInsertText(server, "spbatk "..(_init.spbatk.value and "off" or "on"))
					end
					if gametype==0 then
						_l_restartLevel(server)
					else
						chatprintf(source, "\133<\130STRASHBOT\133>\135 '\129SPBAttack\135' only works in races \133though\135...")
					end
				end
			else
				chatprintf(source, "\133<\130STRASHBOT\133>\135 you can only toggle '\129SPBAttack\135' when you're the \133only\135 racer...")
				return false
			end
		end

		return true
	end
)
for mod,t in pairs(strash_mods.mods) do
	strash_msg_cmd.addMessageCommand(
		mod:lower(),
		function(name, args, source, target)
			if #args<1 then return false end

			local arg1= args[1]:lower()
			strash_log(server, "mod '"..name.."' activation? arg1 is '"..arg1.."'")
			if arg1=="on" then
				voteCtrl(source, name:lower())

				return true
			else
				COM_BufInsertText(source, "vote "..name:lower().."_off")

				return true
			end

			return false
		end
	)
end
strash_msg_cmd.addMessageCommand(
	{"battle","race","battle!","race!","battle?","race?"},
	function(name, args, source, target)
		if name:sub(1,4)=="race" then
			local cmd= (#args>0 and args[1]=="only") and "race!" or name
			_onGametypeStrChange("race", cmd, source)

			return true
		elseif name:sub(1,6)=="battle" then
			local cmd= (#args>0 and args[1]=="only") and "battle!" or name
			_onGametypeStrChange("battle", cmd, source)

			return true
		end

		return false
	end
)
strash_msg_cmd.addMessageCommand(
	{"first","first_to","ft","firstto"},
	function(name, args, source, target)
		local num_arg= ""
		if name=="first" then
			if #args<2 or args[1]~="to" then
				return false
			end

			num_arg= args[2]
		else
			if #args<1 then
				return false
			end

			num_arg= args[1]
		end

		local num= tonumber(num_arg)
		if num==nil then
			return false
		end

		COM_BufInsertText(source, "first_to "..num_arg)

		return true
	end
)
strash_msg_cmd.addMessageCommand(
	{"rtv","exit","exitlevel"},
	function(name, args, source, target)
		COM_BufInsertText(source, "rtv")

		return true
	end
)

local intermission_think_once= false
addHook("IntermissionThinker", function()
	if not intermission_think_once then
		cons_cross_msg("INTERMISSION")
	else
		try_initVar()
	end
	intermission_think_once= true
end)

local voteThinkerCheck= {checked= false, mods_baseProba={}}
addHook("VoteThinker", function()
	try_initVar()
	if (not voteThinkerCheck.checked) then
		cons_cross_msg("VOTESCREEN")
		voteThinkerCheck.checked= true

		-- scaling mods auto pick proba according to number of players
		for modName,t in pairs(strash_mods.mods) do
			if not voteThinkerCheck.mods_baseProba[modName] then
				voteThinkerCheck.mods_baseProba[modName]= {desired=t.desired_proba, pick=t.auto_pick_proba}
			elseif t.desired_proba~=voteThinkerCheck.mods_baseProba[modName].desired then
				voteThinkerCheck.mods_baseProba[modName]= {desired=t.desired_proba, pick=t.auto_pick_proba}
			end
		end

		local c_p= countplayers()

		if c_p<2 then return end

		local diff= c_p-4
		local mod= strash_mods.mods["Friend"]
		if mod then
			local f_diff= (diff/2)*2
			--local f_proba= voteThinkerCheck.mods_baseProba["Friend"].pick + ((f_diff * 2) + (f_diff>0 and (f_diff/2) or 0) )
			local f_proba= voteThinkerCheck.mods_baseProba["Friend"].pick + (f_diff * 2) + ((c_p%2)~=0 and (-15) or (f_diff>0 and (f_diff/2) or 0))
			f_proba= (f_proba<5 and 5 or (f_proba>25 and 25 or f_proba))

			if f_proba~=mod.auto_pick_proba then
				mod.auto_pick_proba= f_proba
				strash_log(server, "Now counting "..c_p.." players: mod \"Friend\" has now pick_proba of "..f_proba.."%")
			end
		end

		--gonna put these on hold for now
		/*mod= strash_mods.mods["Elim"]
		if mod then
			local e_proba= voteThinkerCheck.mods_baseProba["Elim"].pick - (diff * 2 )
			e_proba= (e_proba<7 and 7 or (e_proba>25 and 25 or e_proba))

			if e_proba~=mod.auto_pick_proba then
				mod.auto_pick_proba= e_proba
				strash_log(server, "Now counting "..c_p.." players: mod \"Elim\" has now pick_proba of "..e_proba.."%")
			end
		end

		mod= strash_mods.mods["JuiceBox"]
		if mod then
			--local j_proba= voteThinkerCheck.mods_baseProba["JuiceBox"].pick + ((diff * 2) + (diff>0 and (diff/2) or 0))
			local j_proba= voteThinkerCheck.mods_baseProba["JuiceBox"].pick + (diff * 2)
			j_proba= (j_proba<7 and 7 or (j_proba>25 and 25 or j_proba))

			if j_proba~=mod.auto_pick_proba then
				mod.auto_pick_proba= j_proba
				strash_log(server, "Now counting "..c_p.." players: mod \"JuiceBox\" has now pick_proba of "..j_proba.."%")
			end
		end*/
	end
end)

local function mapLoadMessage(mapnum)
	local mapName= G_BuildMapName(mapnum)
	local mapTitle= mapheaderinfo[mapnum].lvlttl
	if mapName=="MAP22" then
		chatprint("\133<\130STRASHBOT\133>\129 \""..mapTitle.."\"\128's lap count has been set to \1313 \133laps!",true)
	end
end

addHook("MapLoad", function(mapnum)
	try_initVar()
	cons_cross_msg("MAPLOAD")
	
	voteThinkerCheck.checked= false
	
	mapLoadMessage(mapnum)
	
	local c_p= countplayers()
	
	for p in players.iterate do
		if displayplayers[0]==p and _init and _init.trick_reminder and _init.trick_reminder.value then
			COM_BufInsertText(p, "ac_trickreminder off")
		end
		
		if strash_debug.value and (not p.debug_warned) then
			chatprintf(p, "\x85<\x82STRASHBOT\x85> server script is in debug mode. I apologize for the loud console output :(\x80")
			p.debug_warned= true
		end
	end
	
	if _init and _init.spbatk and _init.spbatk.value then
		if c_p>1 then
			COM_BufInsertText(server, "spbatk off")
		else
			cons_cross_msg("SPBATK")
		end
	end

	local cross_msg=""
	local _i=0
	for mod,t in pairs(strash_mods.mods) do
		if t.cool_down>0 then
			t.cool_down= $-1
		end
		if t.activated then
			cross_msg= cross_msg..(_i>0 and ' ' or '')..(t.manually_activated and '*' or '')..mod:upper()
			_i= $+1
		end
	end
	if firstTo~=nil and firstTo>0 then
		cross_msg= cross_msg..(_i>0 and ' ' or '').."FT"..firstTo
	end
	cons_cross_msg(cross_msg)

	if kmp_bumpspark then
		local c= c_p
		
		if c > 6 and (not kmp_bumpspark.value) and (not (JUICEBOX and JUICEBOX.value)) then
			COM_BufInsertText(server, "kmp_bumpspark on")
			chatprint("\135|!| \136 7 \128players threshold reached: \130bumpspark\128 is \131enabled\128!")
			if sfx_sysmsg then S_StartSound(nil, sfx_sysmsg) end		
		elseif c <=6 and kmp_bumpspark.value and (not (JUICEBOX and JUICEBOX.value)) then
			COM_BufInsertText(server, "kmp_bumpspark off")
			chatprint("\135|!| \128Below \136 7 \128players threshold: \130bumpspark\128 is \133\disabled\128!")
			if sfx_sysmsg then S_StartSound(nil, sfx_sysmsg) end	
		end
	end
	
	local mhi= mapheaderinfo[mapnum]
	if mhi and mhi.typeoflevel == 0 then
		print("\133Warning: broken, incompatible, or banned map, leaving immediately...\128")
		COM_BufInsertText(server, "map "..G_BuildMapName(0))
	end
end)

-- "hud drawing add function": https://wiki.srb2.org/wiki/Lua/Functions#Main
hud.add(function(v,p,c)
	if (leveltime<7*TICRATE) then
		local dupadjust = {x=(v.width()/v.dupx()), y=(v.height()/v.dupy())}
		local duptweak = {x=((dupadjust.x - 320)/2), y=((dupadjust.y - 200)/2)}
		local flags= V_SNAPTOTOP | V_SNAPTOLEFT | V_ALLOWLOWERCASE
		
		local str= 
			(gametype==0) and 
				( "KartSpeed:"..(gamespeed>=2 and "\x83 HARD" or (gamespeed==1 and "\x82 NORMAL" or (gamespeed<1 and "\x85 EASY" or "\x86 unknown"))) )
				or ( "\x86 Battle?! " )
		
		local w_str= v.stringWidth(str, flags, "small")
		v.drawString(duptweak.x+295-w_str, duptweak.y+26, str, flags, "small")
	end
end)

-- "NetVars" hook: https://wiki.srb2.org/wiki/Lua/Hooks#MapLoad
addHook("NetVars", function(net)
    -- all this stuff needs to be the same for everyone, yeah
    b_reactivate_spba= net($)
	jb_wait= net($)
	acro_wait= net($)
	voteThinkerCheck= net($)
	intermission_think_once= net($)
end)